//
// This code is part of https://www.grapecity.com/documents-api-pdf/demos.
// Copyright (c) GrapeCity, Inc. All rights reserved.
//
using System;
using System.IO;
using System.Reflection;
using System.Collections.Generic;
using System.Diagnostics;
using GrapeCity.Documents.Pdf;
using GrapeCity.Documents.Pdf.Layers;
using System.Numerics;
using System.Drawing;
using GrapeCity.Documents.Pdf.Graphics;
using GrapeCity.Documents.Drawing;
using GrapeCity.Documents.Text;

Console.WriteLine("Start");
GcPdfDocument doc = new GcPdfDocument();
FileStream fs = new FileStream("test.pdf", FileMode.Open);
doc.Load(fs);

GcPdfDocument newDoc = new GcPdfDocument();
var adjustmentOffsetHeight = doc.PageSize.Height+50;
for (var i = 0; i < doc.Pages.Count; i++)
{
    var translateTransformation = Matrix3x2.CreateTranslation(adjustmentOffsetHeight,0);
    var rotateTransformation = Matrix3x2.CreateRotation((float)(90 * Math.PI) / 180f, new Vector2(adjustmentOffsetHeight, 0)); // rotate 90 degrees
    var newPage = newDoc.NewPage();
    newPage.Size = new SizeF(adjustmentOffsetHeight, newPage.Size.Width);  //Swap height and width dimensions
    var newGraphics = newPage.Graphics;
    var formXObject = new FormXObject(newDoc, doc.Pages[i]);
    newGraphics.DrawString("NEW TEXT", new TextFormat() { Font = StandardFonts.Helvetica, FontSize = 20, ForeColor = Color.Red }, new PointF(0, 0));
    var finalMatrix = Matrix3x2.Multiply(translateTransformation, rotateTransformation);
    newGraphics.Transform = finalMatrix;
    newGraphics.DrawForm(formXObject, doc.Pages[i].Bounds, null, ImageAlign.CenterImage);    
}

newDoc.Save("../../../rotated.pdf");
Console.WriteLine("End");
